﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.IO;
using System.Globalization;
using System.Drawing;

namespace AI_pristavani
{
    class Moon
    {
        public int ID { get; private set; }
        public float X { get; private set; }
        public float Y { get; private set; }
        public float Vx { get; private set; }
        public float Vy { get; private set; }
        public float P { get; private set; }
        public float L { get; private set; }
        public float R { get; private set; }
        public string uri { get; private set; }
        public bool up { get; private set; }
        public bool left { get; private set; }
        public bool right { get; private set; }

        public int state { get; private set; }

        public Moon(string uri) //Vytvoření nové hry ze serveru
        {
            if (!uri.EndsWith("/")) uri += "/";
            this.uri = uri;

            string[] result = request("start");

            ID = int.Parse(result[0]);

            string[] line = result[1].Split(' ');
            X = float.Parse(line[0], CultureInfo.InvariantCulture);
            Y = float.Parse(line[1], CultureInfo.InvariantCulture);

            line = result[2].Split(' ');
            Vx = float.Parse(line[0], CultureInfo.InvariantCulture);
            Vy = float.Parse(line[1], CultureInfo.InvariantCulture);

            P = float.Parse(result[3], CultureInfo.InvariantCulture);

            line = result[4].Split(' ');
            L = float.Parse(line[0], CultureInfo.InvariantCulture);
            R = float.Parse(line[1], CultureInfo.InvariantCulture);
        }

        public void refresh(bool up, bool left, bool right) //Obnovení dat ze serveru
        {
            this.up = up;
            this.left = left;
            this.right = right;

            string[] result = request("stav?id=" + ID + "&nahoru=" + (up ? "1" : "0") + "&doleva=" + (left ? "1" : "0") + "&doprava=" + (right ? "1" : "0"));

            if (result.Count() < 4)
            {
                if (result[0].StartsWith("Zdar"))
                {
                    state = 1;
                }
                if (result[0].StartsWith("Krach"))
                {
                    state = 2;
                }
            }
            else
            {

                ID = int.Parse(result[0]);

                string[] line = result[1].Split(' ');
                X = float.Parse(line[0], CultureInfo.InvariantCulture);
                Y = float.Parse(line[1], CultureInfo.InvariantCulture);

                line = result[2].Split(' ');
                Vx = float.Parse(line[0], CultureInfo.InvariantCulture);
                Vy = float.Parse(line[1], CultureInfo.InvariantCulture);

                P = float.Parse(result[3], CultureInfo.InvariantCulture);

                line = result[4].Split(' ');
                L = float.Parse(line[0], CultureInfo.InvariantCulture);
                R = float.Parse(line[1], CultureInfo.InvariantCulture);
            }
        }

        private string[] request(string page) // Odeslání požadavku a vrácení odpovědi
        {
            List<string> html = new List<string>();
            string url = uri + page;

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            request.AutomaticDecompression = DecompressionMethods.GZip;

            using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())
            using (Stream stream = response.GetResponseStream())
            using (StreamReader reader = new StreamReader(stream))
            {
                while (!reader.EndOfStream)
                {
                    html.Add(reader.ReadLine());
                }
            }

            return html.ToArray();
        }
    }
}
