﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;

namespace AI_pristavani
{
    class Program
    {
        static string url = "http://localhost:8000/";
        static int rychlostniomezeni = int.MaxValue;
        static Moon moon;

        static void Main(string[] args)
        {
            if (args.Count() > 0)
            {
                url = args[0];
                if (!url.StartsWith("http://", StringComparison.OrdinalIgnoreCase)) url = "http://" + url;
            }
            if (url == "") url = "http://localhost:8000/";
            string s = "";
            if (args.Count() > 0)
            {
                s = args[1];
            }
            if (s == "") s = "0";
            rychlostniomezeni = int.Parse(s);
            if (rychlostniomezeni == 0) rychlostniomezeni = int.MaxValue;

            Timer timer = new Timer(10);
            timer.Elapsed += Timer_Elapsed;

            //while (true)
            {
                left = false;
                right = false;
                up = false;
                once = true;
                lbegin = false;
                rbegin = false;

                moon = new Moon(url);
                timer.Start();
                while (moon.state == 0) { }

                timer.Stop();
                Console.Clear();
                Console.WriteLine(moon.state == 1 ? "Zdar!" : "Krach!");
            }
        }

        static bool left = false;
        static bool right = false;
        static bool up = false;

        private static void Timer_Elapsed(object sender, ElapsedEventArgs e) // Každých 10 milisekund
        {
            AI();
            moon.refresh(up, left, right);

            //Výpis debug info do konzole

            StringBuilder builder = new StringBuilder();
            builder.Append("L=");
            builder.Append(moon.L);
            builder.Append(Environment.NewLine);
            builder.Append("R=");
            builder.Append(moon.R);
            builder.Append(Environment.NewLine);
            builder.Append("X=");
            builder.Append(moon.X);
            builder.Append(Environment.NewLine);
            builder.Append("Y=");
            builder.Append(moon.Y);
            builder.Append(Environment.NewLine);
            builder.Append("Vx=");
            builder.Append(moon.Vx);
            builder.Append(Environment.NewLine);
            builder.Append("Vy=");
            builder.Append(moon.Vy);
            builder.Append(Environment.NewLine);
            builder.Append("P=");
            builder.Append(moon.P);
            builder.Append(Environment.NewLine);
            if (up) builder.Append("UP ");
            if (left) builder.Append("LEFT ");
            if (right) builder.Append("RIGHT ");

            Console.Clear();
            Console.WriteLine(builder.ToString());
        }
        static bool once = true;
        static bool lbegin = false;
        static bool rbegin = false;
        private static void AI() // Umělá inteligence
        {
            // Osa X
            if (once)
            {
                if (moon.X + 10 > moon.R)
                {
                    left = true;
                    right = false;
                    lbegin = true;
                }

                if (moon.X - 10 < moon.L)
                {
                    right = true;
                    left = false;
                    rbegin = true;
                }
                once = false;
            }

            //  - Smart way...
            /*
             * if (lbegin) {
                //Console.WriteLine(Math.Abs(((moon.X - moon.Vx * moon.Vx / 4))));
                if (Math.Abs((moon.R - moon.L - 60) / 2 - (moon.X - moon.Vx * moon.Vx / 4)) < 1) {
                    right = true;
                    left = false;
                }
                if (right && Math.Abs(moon.Vx) < 1) {
                    right = false;
                    left = false;
                }
            }

            if (rbegin)
            {
                //Console.WriteLine(Math.Abs(((moon.X - moon.Vx * moon.Vx / 4))));
                if (Math.Abs((moon.R - moon.L + 60) / 2 - (moon.X + moon.Vx * moon.Vx / 4)) < 1)
                {
                    left = true;
                    right = false;
                }
                if (left && Math.Abs(moon.Vx) < 1)
                {
                    right = false;
                    left = false;
                }
            }
            */

            //  - Dumb way...
            
            if (lbegin) {
                if (moon.R > moon.X + 10) {
                    right = true;
                    left = false;
                }
                if (right == true && moon.Vx >= 0) {
                    right = false;
                    left = false;
                }
            }

            if (rbegin)
            {
                if (moon.L < moon.X - 10)
                {
                    right = false;
                    left = true;
                }
                if (left == true && moon.Vx <= 0) {
                    right = false;
                    left = false;
                }
            }
            

            // Osa Y
            if (Math.Abs((moon.Y - 9) - (2.5 * Math.Pow(((-moon.Vy) / 5), 2))) < 1) {
                up = true;
            }
        }
    }
}
