﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GUI_pristani
{
    public partial class Form1 : Form
    {
        string url = "http://localhost:8000/";

        public Form1()
        {
            InitializeComponent();
            url = Microsoft.VisualBasic.Interaction.InputBox("Simulátor přistání na měsíci\r\n\r\nOvládání hry probíhá pomocí: \r\n - Klávesnice (šipky Nahoru, Doleva a Doprava) \r\n - Myši (s levým tlačítkem na rozích obrazovky)\r\n\r\nAdresa serveru:", "Spuštění hry", "http://localhost:8000/");
            if (url == "") {
                this.Close();
                Application.Exit();
                Environment.Exit(0);
            }

            try
            {
                moon = new Moon(url);
            }
            catch {
                MessageBox.Show("Neplatná adresa!");
                this.Close();
                Application.Exit();
                Environment.Exit(0);
            }
            timerRefresh.Start();
        }

        Moon moon;
        List<Keys> pressed = new List<Keys>();

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            moon.paint(e.Graphics, betterPanel1.Height, betterPanel1.Width);
        }

        private void timerRefresh_Tick(object sender, EventArgs e)
        {
            
            moon.refresh(pressed.Contains(Keys.Up), pressed.Contains(Keys.Left), pressed.Contains(Keys.Right));
            if (moon.state == 0)
            {
                betterPanel1.Invalidate();
            }
            else {
                timerRefresh.Stop();
                moon.refresh(false, false, false);
                betterPanel1.Invalidate();
                pressed = new List<Keys>();

                if (moon.state == 1) {
                    MessageBox.Show("Zdar!");
                }
                if (moon.state == 2)
                {
                    MessageBox.Show("Krach!");
                }
                Application.Restart();
            }
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (!pressed.Contains(e.KeyCode)) pressed.Add(e.KeyCode);
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            if (pressed.Contains(e.KeyCode)) pressed.Remove(e.KeyCode);
        }

        bool mouseEnabled = false;

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            mouseEnabled = true;
            Form1_MouseMove(sender, e);
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseEnabled)
            {
                if (e.Location.X < betterPanel1.Width / 3)
                {
                    if (!pressed.Contains(Keys.Left)) pressed.Add(Keys.Left);
                }
                else
                {
                    if (pressed.Contains(Keys.Left)) pressed.Remove(Keys.Left);
                }

                if (e.Location.X > betterPanel1.Width / 3 * 2)
                {
                    if (!pressed.Contains(Keys.Right)) pressed.Add(Keys.Right);
                }
                else
                {
                    if (pressed.Contains(Keys.Right)) pressed.Remove(Keys.Right);
                }
                if (e.Location.Y < betterPanel1.Height / 2)
                {
                    if (!pressed.Contains(Keys.Up)) pressed.Add(Keys.Up);
                }
                else
                {
                    if (pressed.Contains(Keys.Up)) pressed.Remove(Keys.Up);
                }
            }
        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            mouseEnabled = false;
            if (pressed.Contains(Keys.Left)) pressed.Remove(Keys.Left);
            if (pressed.Contains(Keys.Right)) pressed.Remove(Keys.Right);
            if (pressed.Contains(Keys.Up)) pressed.Remove(Keys.Up);
        }
    }
}
